#include <AccelStepper.h>

// Definir pines para DIR y STEP
#define DIR_PIN D2
#define STEP_PIN D1

// Crear un objeto de AccelStepper
AccelStepper stepper(1, STEP_PIN, DIR_PIN);

void setup() {
  // Inicializar la comunicación serial para depuración
  Serial.begin(9600);
  Serial.println("Iniciando secuencia de prueba del motor paso a paso");

  // Establecer la velocidad máxima y la aceleración
  stepper.setMaxSpeed(1000); // Velocidad máxima en pasos por segundo
  stepper.setAcceleration(500); // Aceleración en pasos por segundo al cuadrado

  // Mover a la posición inicial
  stepper.setCurrentPosition(0);
}

void loop() {
  // Girar hacia adelante 200 pasos (un giro completo para un motor de 200 pasos por revolución)
  Serial.println("Girando hacia adelante");
  stepper.moveTo(200);
  stepper.runToPosition();

  delay(1000); // Esperar 1 segundo

  // Girar hacia atrás 200 pasos (regresar a la posición inicial)
  Serial.println("Girando hacia atrás");
  stepper.moveTo(0);
  stepper.runToPosition();

  delay(1000); // Esperar 1 segundo

  // Girar hacia adelante 100 pasos (medio giro)
  Serial.println("Girando medio giro hacia adelante");
  stepper.moveTo(100);
  stepper.runToPosition();

  delay(1000); // Esperar 1 segundo

  // Girar hacia atrás 100 pasos (regresar a la posición inicial)
  Serial.println("Girando medio giro hacia atrás");
  stepper.moveTo(0);
  stepper.runToPosition();

  delay(1000); // Esperar 1 segundo

  // Girar hacia adelante 50 pasos (un cuarto de giro)
  Serial.println("Girando un cuarto de giro hacia adelante");
  stepper.moveTo(50);
  stepper.runToPosition();

  delay(1000); // Esperar 1 segundo

  // Girar hacia atrás 50 pasos (regresar a la posición inicial)
  Serial.println("Girando un cuarto de giro hacia atrás");
  stepper.moveTo(0);
  stepper.runToPosition();

  delay(1000); // Esperar 1 segundo
}
